diff -r 46b67f1569b5 -r 94ccec9b749d scripts/java/org/octave/ClassHelper.java
--- a/scripts/java/org/octave/ClassHelper.java	Wed Aug 03 04:55:05 2016 +0100
+++ b/scripts/java/org/octave/ClassHelper.java	Wed Aug 03 18:43:57 2016 +0200
@@ -531,63 +829,57 @@
         */
         return true;
       }
-    else if (expCls.isArray () && argCls.isArray ()
+
+    if (expCls.isArray () && argCls.isArray ()
              && isCallableFrom (expCls.getComponentType (),
                                 argCls.getComponentType ()))
       {
         return true;
       }
-    else if (expCls.equals (Object.class) && argCls.isPrimitive ())
-      {
-        return true;
-      }
-    else
-      {
-        return false;
-      }
+    
+    return expCls.equals (Object.class) && argCls.isPrimitive ();
+
   }
 
 
   private static boolean isNumberClass (Class cls)
   {
-    return (cls.equals (Integer.TYPE) || cls.equals (Integer.class)
-            || cls.equals (Short.TYPE) || cls.equals (Short.class)
-            || cls.equals (Long.TYPE) || cls.equals (Long.class)
-            || cls.equals (Float.TYPE) || cls.equals (Float.class)
-            || cls.equals (Double.TYPE) || cls.equals (Double.class));
+    // FIXME: seems as if Byte is missing. 
+    return cls.equals (Short.TYPE  ) || cls.equals (Short.class  )
+      ||   cls.equals (Integer.TYPE) || cls.equals (Integer.class)
+      ||   cls.equals (Long.TYPE   ) || cls.equals (Long.class   )
+      ||   cls.equals (Float.TYPE  ) || cls.equals (Float.class  )
+      ||   cls.equals (Double.TYPE ) || cls.equals (Double.class );
   }
 
 
   private static boolean isBooleanClass (Class cls)
   {
-    return (cls.equals (Boolean.class) || cls.equals (Boolean.TYPE));
+    return cls.equals (Boolean.class) || cls.equals (Boolean.TYPE);
   }
 
 
   private static boolean isCharClass (Class cls)
   {
-    return (cls.equals (Character.class) || cls.equals (Character.TYPE));
+    return cls.equals (Character.class) || cls.equals (Character.TYPE);
   }
 
 
-  /**
-   * Check whether the supplied class is a String class.
-   *
-   * Added for more strict char/string mathicng of method signatures
-   * Date: 28-08-2010
-   * Author: Martin Hepperle
-   * @param cls Class - the class to check
-   * @return boolean - true if clas is of class java.lang.String
-   */
-  private static boolean isStringClass (Class cls)
-  {
-    return (
-            cls.equals (String.class)
-            );
-  }
+  //   //  * Check whether the supplied class is a String class.
+  //  *
+  //  * Added for more strict char/string matching of method signatures
+  //  * Date: 28-08-2010
+  //  * Author: Martin Hepperle
+  //  * @param cls Class - the class to check
+  //  * @return boolean - true if clas is of class java.lang.String
+  //   // private static boolean isStringClass (Class cls)
+  // {
+  //   return cls.equals (String.class);
+  // }
 
 
-  private static Object[] castArguments (Object[] args, Class[] argTypes,
+  private static Object[] castArguments (Object[] args, 
+                                         Class[] argTypes,
                                          Class[] expTypes)
   {
     for (int i = 0; i < args.length; i++)
@@ -597,43 +889,51 @@
     return args;
   }
 
-
+  // FIXME: simply null if no success. 
+  // To be analyzed: isn't type just obj.getClass()? 
   private static Object castArgument (Object obj, Class type, Class expType)
   {
-    // System.out.println("expType:"+expType.getCanonicalName() + " <= type:" + type.getCanonicalName());
     if (type == null || expType.isAssignableFrom (type))
       {
         return obj;
       }
-    else if (isNumberClass (expType))
+    if (isNumberClass (expType))
       {
+        Number num = (Number)obj;
+        // FIXME: what if obj is null? 
+        // FIXME: seems as if Byte is missing as in isNumberClass 
+        if (expType.equals (Short.TYPE) || expType.equals (Short.class))
+          {
+            return Short  .valueOf(num. shortValue());
+          }
         if (expType.equals (Integer.TYPE) || expType.equals (Integer.class))
           {
-            return new Integer (((Number) obj).intValue ());
+            return Integer.valueOf(num.   intValue());
           }
-        else if (expType.equals (Double.TYPE) || expType.equals (Double.class))
+        if (expType.equals (Long.TYPE) || expType.equals (Long.class))
           {
-            return new Double (((Number) obj).doubleValue ());
+            return Long   .valueOf(num.  longValue());
           }
-        else if (expType.equals (Short.TYPE) || expType.equals (Short.class))
+        if (expType.equals (Float.TYPE) || expType.equals (Float.class))
           {
-            return new Short (((Number) obj).shortValue ());
+            return Float  .valueOf(num. floatValue());
           }
-        else if (expType.equals (Long.TYPE) || expType.equals (Long.class))
+        if (expType.equals (Double.TYPE) || expType.equals (Double.class))
           {
-            return new Long (((Number) obj).longValue ());
+            return Double .valueOf(num.doubleValue());
           }
-        else if (expType.equals (Float.TYPE) || expType.equals (Float.class))
-          {
-            return new Float (((Number) obj).floatValue ());
-          }
+        throw new IllegalStateException
+          ("Missing branch for byte? found "+expType);
       }
-    else if (isBooleanClass (expType))
+    if (isBooleanClass (expType))
       {
-        return new Boolean (((Number) obj).intValue () != 0);
+        // FIXME: what if obj is null? 
+        // FIXME: why is obj a Number here?? 
+        return Boolean.valueOf(((Number) obj).intValue () != 0);
       }
-    else if (isCharClass (expType))
+    if (isCharClass (expType))
       {
+        // FIXME: what if obj is null? 
         String s = obj.toString ();
         if (s.length () != 1)
           {
@@ -641,22 +941,37 @@
           }
         return new Character (s.charAt (0));
       }
-    else if (expType.isArray () && type.isArray ())
+    if (expType.isArray () && type.isArray ())
       {
-        return castArray (obj, type.getComponentType (),
+        // ensure that cast allows obj==null
+        return castArray (obj, 
+                          type   .getComponentType (),
                           expType.getComponentType ());
       }
-    else if (type.isPrimitive ())
+    if (type.isPrimitive ())
       {
+        // FIXME: appropriate?
         return obj;
       }
     return null;
   }
 
-
-  private static Object castArray (Object obj, Class elemType,
+  //! Cast the given array @c obj componentwise
+  //! from class @c elemType to @c elemExpType.
+  //!
+  //! @param obj
+  //!    the instance of an array.
+  //! @param elemType
+  //!    @c obj's class
+  //! @param elemExpType
+  //!    the target class to cast the entries of @c obj.
+  //! @throws IllegalArgumentException
+  //!    if obj is no array instance.
+  private static Object castArray (Object obj, 
+                                   Class elemType,
                                    Class elemExpType)
   {
+    // throws IllegalArgumentException if obj is not an array instance
     int len = Array.getLength (obj);
     Object result = Array.newInstance (elemExpType, len);
     for (int i = 0; i < len; i++)
@@ -668,68 +983,83 @@
   }
 
 
+  //! Return the mathematical dimension of @c cls. 
+  //! This is 0 if @c cls no array type or if @c null. 
   private static int getArrayClassNDims (Class cls)
   {
-    if (cls != null && cls.isArray ())
+    int res = 0;
+    while (cls != null && cls.isArray ()) 
       {
-        return (1 + getArrayClassNDims (cls.getComponentType ()));
+        res++;
+        cls = cls.getComponentType ();
       }
-    else
-      {
-        return 0;
-      }
+    return res;
+
+    // if (cls != null && cls.isArray ())
+    //   {
+    //     return (1 + getArrayClassNDims (cls.getComponentType ()));
+    //   }
+    // else
+    //   {
+    //     return 0;
+    //   }
   }
 
-
+  //! Return the innermost component type of @c cls. 
   private static Class getArrayElemClass (Class cls)
   {
-    if (cls.isArray ())
+
+    while (cls.isArray ()) 
       {
-        return getArrayElemClass (cls.getComponentType ());
+        cls = cls.getComponentType ();
       }
-    else
-      {
-        return cls;
-      }
+    return cls;
+
+
+    // if (cls.isArray ())
+    //   {
+    //     return getArrayElemClass (cls.getComponentType ());
+    //   }
+    // else
+    //   {
+    //     return cls;
+    //   }
   }
 
 
-  private static Object getArrayElements (Object array, int[][] idx,
+  private static Object getArrayElements (Object array, 
+                                          int[][] idx,
                                           int offset,
                                           int ndims, Class elemType)
   {
     if (offset >= ndims)
       {
         Object elem = Array.get (array, idx[offset][0]);
+        return (offset < idx.length - 1)
+          ? getArrayElements (elem, idx, offset + 1, ndims, elemType)
+          : elem;
+      }
+
+    Class compType = elemType.getComponentType ();
+    Object retval = Array.newInstance (compType, idx[offset].length);
+    for (int i = 0; i < idx[offset].length; i++)
+      {
+        Object elem = Array.get (array, idx[offset][i]);
         if (offset < idx.length - 1)
           {
-            return getArrayElements (elem, idx, offset + 1, ndims, elemType);
+            elem = getArrayElements (elem, idx, offset + 1, ndims, compType);
           }
-        else
-          {
-            return elem;
-          }
+        Array.set (retval, i, elem);
       }
-    else
-      {
-        Class compType = elemType.getComponentType ();
-        Object retval = Array.newInstance (compType, idx[offset].length);
-        for (int i = 0; i < idx[offset].length; i++)
-          {
-            Object elem = Array.get (array, idx[offset][i]);
-            if (offset < idx.length - 1)
-              {
-                elem = getArrayElements (elem, idx, offset + 1, ndims, compType);
-              }
-            Array.set (retval, i, elem);
-          }
-        return retval;
-      }
+    return retval;
+
   }
 
-
-  public static Object arraySubsref (Object obj, int[][] idx)
-    throws Exception
+  // Used by 
+  // #get_array_elements(JNIEnv*, jobject, octave_value_list&) 
+  // in @file ov-java.cc only and is recursive. 
+  //PMD: has an NPath complexity of 582
+  public static Object arraySubsref (Object obj, int[][] idx) // NOPMD
   {
     if (!obj.getClass ().isArray ())
       {
@@ -754,69 +1084,71 @@
             return retval;
           }
       }
-    else
+
+
+    int[] dims = new int[idx.length];
+    for (int i = 0; i < idx.length; i++)
       {
-        int[] dims = new int[idx.length];
-        for (int i = 0; i < idx.length; i++)
+        dims[i] = idx[i].length;
+      }
+
+    if (dims.length != getArrayClassNDims (obj.getClass ()))
+      {
+        throw new IllegalArgumentException ("index size mismatch");
+      }
+
+    /* resolve leading singletons */
+    Object theObj = obj;
+    int offset = 0;
+    while (dims[offset] == 1)
+      {
+        theObj = Array.get (theObj, idx[offset][0]);
+        offset = offset + 1;
+        if (offset >= dims.length)
           {
-            dims[i] = idx[i].length;
+            return theObj;
           }
+      }
+    if (offset > 0)
+      {
+        int[][] new_idx = new int[idx.length - offset][];
+        System.arraycopy (idx, offset, new_idx, 0, idx.length - offset);
+        return arraySubsref (theObj, new_idx);
+      }
 
-        if (dims.length != getArrayClassNDims (obj.getClass ()))
-          {
-            throw new IllegalArgumentException ("index size mismatch");
-          }
+    /* chop trailing singletons */
+    int ndims = dims.length;
+    while (ndims > 1 && dims[ndims - 1] == 1)
+      {
+        ndims--;
+      }
 
-        /* resolve leading singletons */
-        Object theObj = obj;
-        int offset = 0;
-        while (dims[offset] == 1)
-          {
-            theObj = Array.get (theObj, idx[offset][0]);
-            offset = offset + 1;
-            if (offset >= dims.length)
-              {
-                return theObj;
-              }
-          }
-        if (offset > 0)
-          {
-            int[][] new_idx = new int[idx.length - offset][];
-            System.arraycopy (idx, offset, new_idx, 0, idx.length - offset);
-            return arraySubsref (theObj, new_idx);
-          }
+    /* create result array */
+    Class elemClass = theObj.getClass ();
+    for (int i = 0; i <= (dims.length - ndims); i++)
+      {
+        elemClass = elemClass.getComponentType ();
+      }
+    Object retval = Array.newInstance (elemClass, dims[0]);
 
-        /* chop trailing singletons */
-        int ndims = dims.length;
-        while (ndims > 1 && dims[ndims - 1] == 1)
-          {
-            ndims--;
-          }
+    /* fill-in array */
+    for (int i = 0; i < idx[0].length; i++)
+      {
+        Object elem = getArrayElements (Array.get (theObj, idx[0][i]),
+                                        idx, 1, ndims, elemClass);
+        Array.set (retval, i, elem);
+      }
 
-        /* create result array */
-        Class elemClass = theObj.getClass ();
-        for (int i = 0; i <= (dims.length - ndims); i++)
-          {
-            elemClass = elemClass.getComponentType ();
-          }
-        Object retval = Array.newInstance (elemClass, dims[0]);
+    return retval;
 
-        /* fill-in array */
-        for (int i = 0; i < idx[0].length; i++)
-          {
-            Object elem = getArrayElements (Array.get (theObj, idx[0][i]),
-                                            idx, 1, ndims, elemClass);
-            Array.set (retval, i, elem);
-          }
-
-        return retval;
-      }
   }
 
 
-  private static Object setArrayElements (Object array, int[][] idx,
-                                          int offset, int ndims, Object rhs)
-    throws Exception
+  private static Object setArrayElements (Object array,
+                                          int[][] idx,
+                                          int offset, 
+                                          int ndims, 
+                                          Object rhs)
   {
     if (offset >= ndims)
       {
@@ -831,27 +1163,28 @@
           }
         return array;
       }
-    else
+
+    for (int i = 0; i < idx[offset].length; i++)
       {
-        for (int i = 0; i < idx[offset].length; i++)
+        if (offset < idx.length - 1)
           {
-            if (offset < idx.length - 1)
-              {
-                setArrayElements (Array.get (array, idx[offset][i]), idx,
-                                  offset + 1, ndims, Array.get (rhs, i));
-              }
-            else
-              {
-                Array.set (array, idx[offset][i], Array.get (rhs, i));
-              }
+            setArrayElements (Array.get (array, idx[offset][i]), idx,
+                              offset + 1, ndims, Array.get (rhs, i));
           }
-        return array;
+        else
+          {
+            Array.set (array, idx[offset][i], Array.get (rhs, i));
+          }
       }
+    return array;
   }
 
-
-  public static Object arraySubsasgn (Object obj, int[][] idx, Object rhs)
-    throws Exception
+  // PMD: has an NPath complexity of 294
+  // return value seems superfluous. 
+  // Used by @file ov-java.cc only and is recursive. 
+  public static Object arraySubsasgn (Object obj, // NOPMD
+                                      int[][] idx, 
+                                      Object rhs) 
   {
     if (!obj.getClass ().isArray ())
       {
@@ -862,67 +1195,95 @@
       {
         if (idx[0].length == 1)
           {
+            // throws IllegalArgumentException if obj is not an array 
             Array.set (obj, idx[0][0], rhs);
           }
         else
           {
             for (int i = 0; i < idx[0].length; i++)
               {
+                // throws IllegalArgumentException if obj is not an array 
                 Array.set (obj, idx[0][i], Array.get (rhs, i));
               }
           }
         return obj;
       }
-    else
+
+
+    int[] dims = new int[idx.length];
+    for (int i = 0; i < idx.length; i++)
       {
-        int[] dims = new int[idx.length];
-        for (int i = 0; i < idx.length; i++)
-          {
-            dims[i] = idx[i].length;
-          }
+        dims[i] = idx[i].length;
+      }
 
-        if (dims.length != getArrayClassNDims (obj.getClass ()))
-          {
-            throw new IllegalArgumentException ("index size mismatch");
-          }
+    if (dims.length != getArrayClassNDims (obj.getClass ()))
+      {
+        throw new IllegalArgumentException ("index size mismatch");
+      }
 
-        /* resolve leading singletons */
-        Object theObj = obj;
-        int offset = 0;
-        while (dims[offset] == 1 && offset < (dims.length - 1))
-          {
-            theObj = Array.get (theObj, idx[offset][0]);
-            offset = offset + 1;
-          }
-        if (offset > 0)
-          {
-            int[][] new_idx = new int[idx.length - offset][];
-            System.arraycopy (idx, offset, new_idx, 0, idx.length - offset);
-            arraySubsasgn (theObj, new_idx, rhs);
-            return obj;
-          }
-
-        /* chop trailing singletons */
-        int ndims = dims.length;
-        while (ndims > 1 && dims[ndims - 1] == 1)
-          {
-            ndims--;
-          }
-
-        for (int i = 0; i < idx[0].length; i++)
-          {
-            setArrayElements (Array.get (theObj, idx[0][i]), idx, 1, ndims,
-                              Array.get (rhs, i));
-          }
-
+    /* resolve leading singletons */
+    Object theObj = obj;
+    int offset = 0;
+    while (dims[offset] == 1 && offset < (dims.length - 1))
+      {
+        theObj = Array.get (theObj, idx[offset][0]);
+        offset = offset + 1;
+      }
+    if (offset > 0)
+      {
+        int[][] new_idx = new int[idx.length - offset][];
+        System.arraycopy (idx, offset, new_idx, 0, idx.length - offset);
+        arraySubsasgn (theObj, new_idx, rhs);
         return obj;
       }
+
+    /* chop trailing singletons */
+    int ndims = dims.length;
+    while (ndims > 1 && dims[ndims - 1] == 1)
+      {
+        ndims--;
+      }
+
+    for (int i = 0; i < idx[0].length; i++)
+      {
+        setArrayElements (Array.get (theObj, idx[0][i]), idx, 1, ndims,
+                          Array.get (rhs, i));
+      }
+
+    return obj;
   }
 
-
+  //! Return an array with entry type given by @c cls
+  //! with dimensions given by @c dims.
+  //! The class may be given directly as a @ref Class object
+  //! or as a string via its name.
+  //! Used by @c javaArray only.
+  //!
+  //! @param cls
+  //!    the atomic component class given as a class object or as a string.
+  //!    If given as a string, the class is loaded via #loader.
+  //! @param dims
+  //!    the dimensions which shall be non-negative but less than 256.
+  //! @return
+  //!    an array with the given component type.
+  //!    If @c cls is a string, the class is loaded by #loader.
+  //! @throws ClassNotFoundException
+  //!    if @c cls is a string representing a class name
+  //!    and if #loader could not find the according class.
+  // based on loader but only partially. 
+  // used by javaArray.m
   public static Object createArray (Object cls, int[] dims)
-    throws Exception
+    throws ClassNotFoundException
   {
+    // FIXME: seems as if used in javaArray.m only.  
+    // Then more appropriate seems split into two methods: 
+    // one with cls is a Class other one with cls is a String 
+    // FIXME: if a class is given directly, 
+    // it is not guaranteed, that this is loaded via #loader 
+    // So this shall be fixed. 
+    // Typically, different usages are treated in m file invoking error 
+    // in the last else branch. 
+    // This would be appropriate here also. 
     Class theClass;
     if (cls instanceof Class)
       {
@@ -930,6 +1291,7 @@
       }
     else if (cls instanceof String)
       {
+        // may throw ClassNotFoundException
         theClass = Class.forName ((String) cls, true, loader);
       }
     else
@@ -942,9 +1304,9 @@
   }
 
 
-  public static Object createArray (Object cls, int length)
-    throws Exception
-  {
-    return createArray (cls, new int[] {length});
-  }
+  // public static Object createArray (Object cls, int length)
+  //   throws ClassNotFoundException
+  // {
+  //   return createArray (cls, new int[] {length});
+  // }
 }
diff -r 46b67f1569b5 -r 94ccec9b749d scripts/java/org/octave/OctClassLoader.java
--- a/scripts/java/org/octave/OctClassLoader.java	Wed Aug 03 04:55:05 2016 +0100
+++ b/scripts/java/org/octave/OctClassLoader.java	Wed Aug 03 18:43:57 2016 +0200
@@ -24,16 +24,31 @@
 
 import java.io.File;
 
-public class OctClassLoader extends java.net.URLClassLoader
+import java.net.URL;
+import java.net.URLClassLoader;
+
+//! The system class loader for a Java virtual machines (JVM)
+//! created by Octave
+//! (see method <code>initialize_jvm</code> in <code>ov-java.cc</code>).
+//! This is used to load all classes from the dynamic class path.
+//! It is also used to load classes from the static class path
+//! delegating class loading to the parent classloader.
+//! <p>
+//! Class @ref ClassHelper uses @ref OctClassLoader to load classes
+//! for calling constructors and static methods
+//! and for accessing static fields.
+//! To add an entry of the classpath, invoke ::addURL(URL)
+//! whereas to remove an entry, a new classloader is created.
+public class OctClassLoader extends URLClassLoader
 {
   public OctClassLoader ()
   {
-    super (new java.net.URL[0]);
+    super (new URL[0]);
   }
 
   public OctClassLoader (ClassLoader parent)
   {
-    super (new java.net.URL[0], parent);
+    super (new URL[0], parent);
   }
 
   protected Class findClass (String name) throws ClassNotFoundException
@@ -47,27 +62,30 @@
     // Look dynamically into java.library.path, because Sun VM does
     // not do it (seems to cache initial java.library.path instead)
 
-    String[] paths = System.getProperty ("java.library.path").split (File.pathSeparator);
+    String[] paths = System.getProperty ("java.library.path")
+      .split (File.pathSeparator);
 
     libname = System.mapLibraryName (libname);
     for (int i = 0; i < paths.length; i++)
       {
         File f = new File (paths[i], libname);
         if (f.exists ())
-          return f.getAbsolutePath ();
+          {
+            return f.getAbsolutePath ();
+          }
       }
 
     return null;
   }
 
-  public void addClassPath (String name) throws Exception
-  {
-    java.io.File f = new java.io.File (name);
-    addURL (f.toURI ().toURL ());
-  }
+  // public void addClassPath (String name) throws MalformedURLException
+  // {
+  //   File f = new File (name);
+  //   addURL (f.toURI ().toURL ());
+  // }
 
   // new -MH-
-  public void addURL (java.net.URL url)
+  public void addURL (URL url)
   {
     super.addURL (url);
   }
